/*
 *  @Abstract Class Aluno
 *
 *  Na classe abstrata definiremos as propriedades e mtodos que so comuns
 *   todas as derivadas desta classe e tambm podemos definir assinaturas 
 *  de mtodos que tem implementaes distintas nas derivadas. Estes ltimos
 *  tero a sua implementao pendente devendo ser implementados nas derivadas
 *
 */
abstract class Aluno
{
	protected String Nome;
	protected double Notas[] = new double[3]; // instanciando o vetor de 3 posicoes
	
	public void atribuir(String N, double N1, double N2, double N3)
	{
		Nome = N;
		Notas[0] = N1;
		Notas[1] = N2;
		Notas[2] = N3;
	}
	
	public String qualNome()
	{
		return Nome;
	}
	
	public double qualNota(int Qual)
	{
		if ( (Qual>2) || (Qual<0)) return 0;
		return Notas[Qual];
	}

    // Definio dos mtodos abstratos
	public abstract double qualMedia();
	
}

/*
 *  A classe AlunoGrad vai herdar todos os mtodos da classe abstrata e implementar todos
 *  os que l foram deixados pendentes respeitando as assinaturas l definidas.
 *
 *  Perceba que as propriedades NO so mais definidas, apensar de podermos ter 
 *  propriedades especficas para AlunoGrad
 *
 *  Apenas os mtodos que tem implementao especfica para esta derivada devem ser
 *  implementados aqui.
 */
class AlunoGrad extends Aluno
{
	/*
	 * Calculo da mdia Ponderada
	 */
	public double qualMedia()
	{
		return ((Notas[0] + 
		         Notas[1] * 2 + 
		         Notas[2] * 3
		        ) / 6
		       );
	}
}

/*
 *  A classe AlunoPos vai herdar todos os mtodos da classe abstrata e implementar todos
 *  os que l foram deixados pendentes respeitando as assinaturas l definidas.
 *
 *  Perceba que as propriedades NO so mais definidas, apensar de podermos ter 
 *  propriedades especficas para AlunoPos
 *
 *  Apenas os mtodos que tem implementao especfica para esta derivada devem ser
 *  implementados aqui.
 */
  
class AlunoPos extends Aluno
{
	
	/*
	 * Calculo da mdia Aritmtica
	 */
	public double qualMedia()
	{
		return ((Notas[0] + 
		         Notas[1] + 
		         Notas[2] 
		        ) / 3
		       );
	}
}

class Principal
{
	public static void main(String Args[])
	{
		/*
		 *  Vamos declarar um objeto da interface Aluno e atribuir a ele uma
		 *  instncia da classe AlunoGrad
		 */
		Aluno MeuAluno = new AlunoGrad();
		
		
		MeuAluno.atribuir("Andreia",5.5,7.0,9.0);
		System.out.println("Dados de Aluno de Graduacao");
		System.out.println("------------------------------------------");
		System.out.println("Nome..... : " + MeuAluno.qualNome());
		System.out.println("1a.Nota.. : " + MeuAluno.qualNota(0));
		System.out.println("2a.Nota.. : " + MeuAluno.qualNota(1));
		System.out.println("3a.Nota.. : " + MeuAluno.qualNota(2));
		System.out.println("Media.... : " + MeuAluno.qualMedia());
		System.out.println("------------------------------------------");
		
		/*
		 * Agora vamos criar uma nova instncia sobre o mesmo objeto mas agora 
		 * usaremes uma instncia da classe ALlunoPos.
		 * Perceba na impressao da mdia que o valor  diferente mesmo os dados
		 * sendo iguais
		 */
		MeuAluno = new AlunoPos();
		MeuAluno.atribuir("Andreia",5.5,7.0,9.0);
		System.out.println("Dados de Aluno de Pos-Graduacao");
		System.out.println("------------------------------------------");
		System.out.println("Nome..... : " + MeuAluno.qualNome());
		System.out.println("1a.Nota.. : " + MeuAluno.qualNota(0));
		System.out.println("2a.Nota.. : " + MeuAluno.qualNota(1));
		System.out.println("3a.Nota.. : " + MeuAluno.qualNota(2));
		System.out.println("Media.... : " + MeuAluno.qualMedia());
		System.out.println("------------------------------------------");
		
		
	}
}